unit BasicQuotesU1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  StringSRs{to link us to the unit (without a form) that we added by hand},
  DisplayU1{to link us to the unit-with-a-form that we added by hand},
  FileUtil{to give access to the FindAllFiles function... but this
    reference to the always-available unit it is in had to be added by hand};

//See below for vers

type

  { TBasicQuotesF1 }

  TBasicQuotesF1 = class(TForm)
    buQuit: TButton;
    buDoCopyFile: TButton;
    cbDispOnTop: TCheckBox;
    laTxtTimerActive: TLabel;
    laTxtTimerActive1: TLabel;
    meFilesAvail: TMemo;
    meMsgs: TMemo;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    rgCycleSpeed: TRadioGroup;
    Timer1: TTimer;
    procedure buDoCopyFileClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure cbDispOnTopChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    function DoCopyAFile:boolean;
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    iCountOfFilesAvail:integer;
    sPathToQuoteSupply,sPathToDest:string;
    iMsBetweenImageChanges:integer;
  public

  end;

const
  vers='14 Apr 21';
  //Started 12 Apr 21, when I should have been doing taxes!
  kMsFor10Sec=2000;//Keep this and next in step
  kTxt10sec='2 seconds';
  kMsFor3Min=3*60000;//Keep this and next in step
  kTxt3Min='3 minutes';

var
  BasicQuotesF1: TBasicQuotesF1;

implementation

{$R *.lfm}

{ TBasicQuotesF1 }

procedure TBasicQuotesF1.buQuitClick(Sender: TObject);
begin
  close;
end;//buQuitClick

procedure TBasicQuotesF1.cbDispOnTopChange(Sender: TObject);
begin
  if cbDispOnTop.checked then displayf1.FormStyle:=fsSystemStayOntop//no ; here
    else displayf1.FormStyle:=fsNormal;
end;

procedure TBasicQuotesF1.buDoCopyFileClick(Sender: TObject);
begin
  if DoCopyAFile=false then meMsgs.lines.add('There was a problem, Houston');
end;

function TBasicQuotesF1.DoCopyAFile:boolean;
//https://wiki.freepascal.org/CopyFile
var boTmp:boolean;
  iTmp:integer;
begin
  //Pick a file in the "library"
  iTmp:=random(mefilesAvail.lines.count);

  //Put it in place for the "dynamic" webpage...
  boTmp:=CopyFile(mefilesAvail.lines[iTmp],sPathToDest+'JpgForTweak.jpg');

  //If there wasn't, for one thing, a problem with the file SPECIFIED
  //   then put it on the local machine's screen, too...
  if boTmp
    then DisplayF1.imgDisplay.picture.loadfromfile(mefilesAvail.lines[iTmp]);
  result:=boTmp;
end;//DoCopyAFile

procedure TBasicQuotesF1.RadioButton1Change(Sender: TObject);
begin
  iMsBetweenImageChanges:=kMsFor10Sec;
  Timer1.interval:=iMsBetweenImageChanges;
end;


procedure TBasicQuotesF1.RadioButton2Change(Sender: TObject);
begin
  //In the program as it stands, we don't need iMsBetweenImageChanges.
  //But there are various extensions to it which WOULD need a variable
  //  to keep track of the current cycle frequency.
  iMsBetweenImageChanges:=kMsFor3Min;
  Timer1.interval:=iMsBetweenImageChanges;
end;


procedure TBasicQuotesF1.Timer1Timer(Sender: TObject);
var chTmp:char;//Just to check that access to SR in secondary unit working.
begin
  chTmp:=chRightEnd('abcd');
  DoCopyAFile;
end;

procedure TBasicQuotesF1.FormCreate(Sender: TObject);
begin
  //START ============ Do in ini file in due course...
  //Path to folder with img files...
  //Ini file SECTION: [WhereAt]
  // [WhereAt] ini file key-  PathToQuoteSupply:
  sPathToQuoteSupply:='QuotesSupply\';//(Set to 'X' to use a SUBFOLDER
    //called X in app's folder. Or use 'C://xxxx/yyy/zzz...'- as
    //complex as you like
  //to do>if chRightEnd(sPathToQuoteSupply)='/' then
     //  ChangeRightEndToFwdSlash(sPathToQuoteSupply);
  //to do>if chRightEnd(sPathToQuoteSupply)<>'\' then
     //  sPathToQuoteSupply:=sPathToQuoteSupply+'\';

  sPathToDest:='C:\wamp64\www\images\';

  //Do in ini file in due course ============ END

  meMsgs.clear;


  //Okay... I got a bit carried away with ELEGANT PROGRAMMING
  //  for setting the interval times!...
  iMsBetweenImageChanges:=kMsFor10Sec;
  RadioButton1.checked:=true;
  RadioButton1.caption:='Change image every '+kTxt10Sec;
  RadioButton2.caption:='Change image every '+kTxt3Min;

end;//FormCreate

procedure TBasicQuotesF1.FormActivate(Sender: TObject);
var strlstTmp:TStringList;
begin
  iCountOfFilesAvail:=0;//in case folder not accessible
  (*Fill meFilesAvail...
   (see https://wiki.freepascal.org/FindAllFiles)
   (From there) IMPORTANT NOTE: The function "FindAllFiles" creates the
       stringlist internally. This may look very convenient at first sight,
       but it is very easy to create memory leaks that way- DON'T EVER
       DO THIS... There is no way to destroy the stringlist
       created by FindAllFiles.
    BAD: Listbox1.Items.Assign(FindAllFiles
            (LazarusDirectory, '*.pas;*.pp;*.p;*.inc', true);
  *)

  //No need to create the stringlist; the function does that for you
  //To use FindAllFiles, add FileUtil to "Uses" list
    //... FindAllFiles(sPathToQuoteSupply, '*.pas;*.pp;*.p;*.inc', true); //find e.g. all pascal sourcefiles
    strlstTmp:= FindAllFiles(sPathToQuoteSupply, '*.*', true);
    try
      //ShowMessage(Format('Found %d files', [strlstTmp.Count]));
      if strlstTmp.Count=0 then begin
          showmessage('No files found in '+
            sPathToQuoteSupply);
          end//no ; here
        else begin
          meFilesAvail.lines:=strlstTmp;
          iCountOfFilesAvail:=strlstTmp.Count;
          end;//else
    finally
      strlstTmp.Free;
    end;

  //These two need (?) to be in FormActivate, not FormCreate
  //DisplayF1.show;//Bad idea! Comes up... but won't let you go anywhere else!
  //I THINK it is making it come up in a "modal" state... i.e. you have to
  //  "deal with it" before it will go away... but you haven't even given
  //  it a WAY to "deal with it", not that you'd want to have to, anyway.
  DisplayF1.Visible:=true;//Does what we want. NOT the same as using "show".

  DoCopyAFile;

end;//FormActivate

procedure TBasicQuotesF1.Memo2Change(Sender: TObject);
begin

end;

end.

